unit sdl_mixer;

{
  Automatically converted by H2Pas 0.99.15 from sdl_mixer.h
  The following command line parameters were used:
    sdl_mixer.h
}

   { ***Edited by [DaRk_AsM], darknoid@yahoo.com*** }

interface

uses crt,SDL_types,SDL__rwops,SDL_audio;

{$PACKRECORDS 4}

  Type
     PByte     = ^Byte;

  { Set up for C function definitions, even when using C++  }
{ C++ extern C conditionnal removed }
  { The default mixer has 8 simultaneous mixing channels  }

  const
     MIX_CHANNELS = 8;
  { Good default values for a PC soundcard  }

  const
     MIX_DEFAULT_FREQUENCY = 22050;
  const
     MIX_DEFAULT_FORMAT = AUDIO_S16LSB;

  const
     MIX_DEFAULT_CHANNELS = 2;
  { Volume of a chunk  }
     MIX_MAX_VOLUME = 128;
  { The internal format for an audio chunk  }
  { Per-sample volume, 0-128  }

  type
     Mix_Chunk = ^tMix_Chunk;
     tMix_Chunk = record
          allocated : longint;
          abuf : ^Uint8;
          alen : Uint32;
          volume : Uint8;
       end;
  { The different fading types supported  }

     Mix_Fading = (MIX_NO_FADING,MIX_FADING_OUT,MIX_FADING_IN
       );

  { The internal format for a music chunk interpreted via mikmod  }
  Mix_Music=^_Mix_Music;
  _Mix_Music=record
    udata:pointer;
    stream:Pbyte;
    len:Longint;
  end;

  { Open the mixer with a certain audio format  }
function Mix_OpenAudio(frequency:longint; format:Uint16; channels,chunksize:Longint):Longint;cdecl;
    { Dynamically change the number of channels managed by the mixer.
       If decreasing the number of channels, the upper channels are
       stopped.
       This function returns the new number of allocated channels.
      }
function Mix_AllocateChannels(numchans:longint):Longint;cdecl;

    { Find out what the actual audio device parameters are.
       This function returns 1 if the audio has been opened, 0 otherwise.
      }
function Mix_QuerySpec(var frequency:longint;var format:uint16; var channels:longint):longint;cdecl;

    { Load a wave file or a music (.mod .s3m .it .xm) file  }
function Mix_LoadWAV_RW(src:pSDL_RWops;freesrc:longint):Mix_Chunk;cdecl;

    { was #define dname(params) para_def_expr }
    { argument types are unknown }
    { return type might be wrong }   
    function Mix_LoadWAV(mfile : pchar) : Mix_Chunk;cdecl;
    function Mix_LoadMUS(mfile:pchar):Mix_Music;cdecl;

    { Load a wave file of the mixer format from a memory buffer  }
function Mix_QuickLoad_WAV(mem:pbyte):Mix_Chunk;cdecl;

    { Free an audio chunk previously loaded  }
procedure Mix_FreeChunk(chunk:Mix_Chunk);cdecl;
procedure Mix_FreeMusic(music:Mix_Music);cdecl;

    { Set a function that is called after all mixing is performed.
       This can be used to provide real-time visual display of the audio stream
       or add a custom mixer filter for the stream data.
     }
procedure Mix_SetPostMix(var mix_func:pbyte);cdecl;

    { Add your own music player or additional mixer function.
       If 'mix_func' is NULL, the default music player is re-enabled.
      }
Procedure Mix_HookMusic(mix_func:pbyte);cdecl;

    { Add your own callback when the music has finished playing.
      }
Procedure Mix_HookMusicFinished(music_finished:pbyte);cdecl;

    { Get a pointer to the user data for the current music hook  }
Procedure Mix_GetMusicHookData;cdecl;

    { Reserve the first channels (0 -> n-1) for the application, i.e. don't allocate
       them dynamically to the next sample if requested with a -1 value below.
       Returns the number of reserved channels.
      }
Function Mix_ReserveChannels(num:Longint):Longint;cdecl;

    { Channel grouping functions  }
    { Attach a tag to a channel. A tag can be assigned to several mixer
       channels, to form groups of channels.
       If 'tag' is -1, the tag is removed (actually -1 is the tag used to
       represent the group of all the channels).
       Returns true if everything was OK.
      }
Function Mix_GroupChannel(which,tag:Longint):Longint;cdecl;

    { Assign several consecutive channels to a group  }
Function Mix_GroupChannels(from, dest, tag:Longint):Longint;cdecl;

    { Finds the first available channel in a group of channels  }
Function Mix_GroupAvailable(tag:Longint):Longint;cdecl;

    { Returns the number of channels in a group. This is also a subtle
       way to get the total number of channels when 'tag' is -1
      }
Function Mix_GroupCount(tag:Longint):longint;cdecl;

    { Finds the "oldest" sample playing in a group of channels  }
Function Mix_GroupOldest(tag:Longint):Longint;cdecl;

    { Finds the "most recent" (i.e. last) sample playing in a group of channels  }
Function Mix_GroupNewer(tag:Longint):Longint;cdecl;

    { Play an audio chunk on a specific channel.
       If the specified channel is -1, play on the first free channel.
       If 'loops' is greater than zero, loop the sound that many times.
       If 'loops' is -1, loop inifinitely (~65000 times).
       Returns which channel was used to play the sound.
     }
    { was #define dname(params) para_def_expr }
    { argument types are unknown }
    { return type might be wrong }   
function Mix_PlayChannel(channel:longint;chunk:Mix_Chunk;loops : longint) : longint;cdecl;

    { The same as above, but the sound is played at most 'ticks' milliseconds  }
Function Mix_PlayChannelTimed(channel:longint; chunk:Mix_Chunk; loops, ticks:Longint):Longint;cdecl;
Function Mix_PlayMusic(music:Mix_Music;loops:Longint):Longint;cdecl;

    { Fade in music or a channel over "ms" milliseconds, same semantics as the "Play" functions  }
Function Mix_FadeInMusic(music:Mix_Music; loops, ms:Longint):Longint;cdecl;

    { was #define dname(params) para_def_expr }
    { argument types are unknown }
    { return type might be wrong }   
function Mix_FadeInChannel(channel:longint;chunk:Mix_Chunk;loops,ms : longint) : longint;cdecl;
Function Mix_FadeInChannelTimed(channel:Longint; chunk:Mix_Chunk; loops,ms,ticks:Longint):Longint;cdecl;

    { Set the volume in the range of 0-128 of a specific channel or chunk.
       If the specified channel is -1, set volume for all channels.
       Returns the original volume.
       If the specified volume is -1, just return the current volume.
     }
Function Mix_Volume(channel, volume:Longint):Longint;cdecl;
Function Mix_VolumeChunk(chunk:Mix_Chunk;volume:Longint):longint;cdecl;
Function Mix_VolumeMusic(volume:Longint):longint;cdecl;

    { Halt playing of a particular channel  }
Function Mix_HaltChannel(channel:longint):longint;cdecl;
Function Mix_HaltGroup(tag:Longint):Longint;cdecl;
Function Mix_HaltMusic():Longint;cdecl;

    { Change the expiration delay for a particular channel.
       The sample will stop playing after the 'ticks' milliseconds have elapsed,
       or remove the expiration if 'ticks' is -1
     }
Function Mix_ExpireChannel(channel, ticks:longint):longint;cdecl;

    { Halt a channel, fading it out progressively till it's silent
       The ms parameter indicates the number of milliseconds the fading
       will take.
      }
Function Mix_FadeOutChannel(which, ms:longint):longint;cdecl;
Function Mix_FadeOutGroup(tag, ms:longint):longint;cdecl;
Function Mix_FadeOutMusic(ms:longint):longint;cdecl;

    { Query the fading status of a channel  }
Function Mix_FadingMusic:Mix_Fading;cdecl;
Function Mix_FadingChannel(which:longint):Mix_Fading;cdecl;
 
    { Pause/Resume a particular channel  }
Procedure Mix_Pause(channel:Longint);cdecl;
Procedure Mix_Resume(channel:longint);cdecl;
Function Mix_Paused(channel:longint):longint;cdecl;

    { Pause/Resume the music stream  }
Procedure Mix_PauseMusic;cdecl;
Procedure Mix_ResumeMusic;cdecl;
Procedure Mix_RewindMusic;cdecl;
Function Mix_PausedMusic:Longint;cdecl;

    { Check the status of a specific channel.
       If the specified channel is -1, check all channels.
     }
Function Mix_Playing(channel:longint):longint;cdecl;
Function Mix_PlayingMusic:longint;cdecl;

    { Stop music and set external music playback command  }
Function Mix_SetMusicCMD(const command:Pchar):Longint;cdecl;

    { Close the mixer, halting all playing audio  }
Procedure Mix_CloseAudio;cdecl;

    { Ends C function definitions when using C++  }
{ C++ end of extern C conditionnal removed }

implementation

function Mix_OpenAudio(frequency:longint; format:Uint16; channels,chunksize:Longint):Longint;cdecl;external 'SDL_Mixer';
function Mix_AllocateChannels(numchans:longint):Longint;cdecl;external 'SDL_Mixer';
function Mix_QuerySpec(var frequency:longint;var format:uint16; var channels:longint):longint;cdecl;external 'SDL_Mixer';
function Mix_LoadWAV_RW(src:pSDL_RWops;freesrc:longint):Mix_Chunk;cdecl;external 'SDL_Mixer';
function Mix_LoadMUS(mfile:pchar):Mix_Music;cdecl;external 'SDL_Mixer';
function Mix_QuickLoad_WAV(mem:pbyte):Mix_Chunk;cdecl;external 'SDL_Mixer';
procedure Mix_FreeChunk(chunk:Mix_Chunk);cdecl;external 'SDL_Mixer';
procedure Mix_FreeMusic(music:Mix_Music);cdecl;external 'SDL_Mixer';
procedure Mix_SetPostMix(var mix_func:pbyte);cdecl;external 'SDL_Mixer';
Procedure Mix_HookMusic(mix_func:pbyte);cdecl;external 'SDL_Mixer';
Procedure Mix_HookMusicFinished(music_finished:pbyte);cdecl;external 'SDL_Mixer';
Procedure Mix_GetMusicHookData;cdecl;external 'SDL_Mixer';
Function Mix_ReserveChannels(num:Longint):Longint;cdecl;external 'SDL_Mixer';
Function Mix_GroupChannel(which,tag:Longint):Longint;cdecl;external 'SDL_Mixer';
Function Mix_GroupChannels(from, dest, tag:Longint):Longint;cdecl;external 'SDL_Mixer';
Function Mix_GroupAvailable(tag:Longint):Longint;cdecl;external 'SDL_Mixer';
Function Mix_GroupCount(tag:Longint):longint;cdecl;external 'SDL_Mixer';
Function Mix_GroupOldest(tag:Longint):Longint;cdecl;external 'SDL_Mixer';
Function Mix_GroupNewer(tag:Longint):Longint;cdecl;external 'SDL_Mixer';
Function Mix_PlayChannelTimed(channel:longint; chunk:Mix_Chunk; loops, ticks:Longint):Longint;cdecl;external 'SDL_Mixer';
Function Mix_PlayMusic(music:Mix_Music;loops:Longint):Longint;cdecl;external 'SDL_Mixer';
Function Mix_FadeInMusic(music:Mix_Music; loops, ms:Longint):Longint;cdecl;external 'SDL_Mixer';
Function Mix_FadeInChannelTimed(channel:Longint; chunk:Mix_Chunk; loops,ms,ticks:Longint):Longint;cdecl;external 'SDL_Mixer';
Function Mix_Volume(channel, volume:Longint):Longint;cdecl;external 'SDL_Mixer';
Function Mix_VolumeChunk(chunk:Mix_Chunk;volume:Longint):longint;cdecl;external 'SDL_Mixer';
Function Mix_VolumeMusic(volume:Longint):longint;cdecl;external 'SDL_Mixer';
Function Mix_HaltChannel(channel:longint):longint;cdecl;external 'SDL_Mixer';
Function Mix_HaltGroup(tag:Longint):Longint;cdecl;external 'SDL_Mixer';
Function Mix_HaltMusic():Longint;cdecl;external 'SDL_Mixer';
Function Mix_ExpireChannel(channel, ticks:longint):longint;cdecl;external 'SDL_Mixer';
Function Mix_FadeOutChannel(which, ms:longint):longint;cdecl;external 'SDL_Mixer';
Function Mix_FadeOutGroup(tag, ms:longint):longint;cdecl;external 'SDL_Mixer';
Function Mix_FadeOutMusic(ms:longint):longint;cdecl;external 'SDL_Mixer';
Function Mix_FadingMusic:Mix_Fading;cdecl;external 'SDL_Mixer';
Function Mix_FadingChannel(which:longint):Mix_Fading;cdecl;external 'SDL_Mixer';
Procedure Mix_Pause(channel:Longint);cdecl;external 'SDL_Mixer';
Procedure Mix_Resume(channel:longint);cdecl;external 'SDL_Mixer';
Function Mix_Paused(channel:longint):longint;cdecl;external 'SDL_Mixer';
Procedure Mix_PauseMusic;cdecl;external 'SDL_Mixer';
Procedure Mix_ResumeMusic;cdecl;external 'SDL_Mixer';
Procedure Mix_RewindMusic;cdecl;external 'SDL_Mixer';
Function Mix_PausedMusic:Longint;cdecl;external 'SDL_Mixer';
Function Mix_Playing(channel:longint):longint;cdecl;external 'SDL_Mixer';
Function Mix_PlayingMusic:longint;cdecl;external 'SDL_Mixer';
Function Mix_SetMusicCMD(const command:Pchar):Longint;cdecl;external 'SDL_Mixer';
Procedure Mix_CloseAudio;cdecl;external 'SDL_Mixer';

    function Mix_LoadWAV(mfile : pchar) : Mix_Chunk;cdecl;
      var t:Mix_Chunk;
      begin
         t:=Mix_LoadWAV_RW(SDL_RWFromFile(mfile,'rb'),1);

         Mix_LoadWAV:=t;
      end;

    function Mix_PlayChannel(channel:longint;chunk:Mix_Chunk;loops : longint) : longint;cdecl;
      begin
         Mix_PlayChannel:=Mix_PlayChannelTimed(channel,chunk,loops,-(1));
      end;

    function Mix_FadeInChannel(channel:longint;chunk:Mix_Chunk;loops,ms : longint) : longint; cdecl;
      begin
         Mix_FadeInChannel:=Mix_FadeInChannelTimed(channel,chunk,loops,ms,-(1));
      end;

end.
